#include <cfloat>
#include "camera.h"

void Camera::
render_image(Array2<Vec3f>& image) const
{
   // first invert the model-matrix transformation to speed up transforming rays from
   // camera space to world space.
   Transformation mvinv=inverse(modelview);
   // black out the image, resizing it to the desired dimensions
   image.assign(pixel_width, pixel_height, Vec3f(0,0,0));
   // loop over all pixels, tracing rays as we go
   for(int j=0; j<pixel_height; ++j){
      for(int i=0; i<pixel_width; ++i){
         Ray ray=generate_ray(mvinv, i+0.5, j+0.5);
         image(i,j)=raytracer.trace_ray(ray); // here's where we actually do raytracing for this pixel
      }
      // provide some feedback on the progress of the raytracer
      if(j%20==19) std::cout<<" scanline "<<j+1<<" of "<<pixel_height<<std::endl;
      else std::cout<<"."<<std::flush;
   }
}

Ray Camera::
generate_ray(const Transformation& modelview_inverse, float pixel_x, float pixel_y) const
{
   // @@@ ADD CODE HERE
   // You need to write code here that returns a ray
   // in world space corresponding to the given pixel
   // location. The transformation modelview_inverse
   // gives a mapping from camera space to world space.
   // @@@

   return Ray(); // this is not the right code, but stops the compiler from complaining at the start
}

